osg::Drawable Class Reference

`#include <Drawable>`

Inheritance diagram for osg::Drawable:

## Classes

struct | ComputeBoundingBoxCallback
struct | CreateVertexArrayStateCallback
struct | DrawCallback
class | AttributeFunctor
class | ConstAttributeFunctor

## Public Types

enum

AttributeTypes {
VERTICES = 0 , WEIGHTS = 1 , NORMALS = 2 , COLORS = 3 ,
SECONDARY_COLORS = 4 , FOG_COORDS = 5 , ATTRIBUTE_6 = 6 , ATTRIBUTE_7 = 7 ,
TEXTURE_COORDS = 8 , TEXTURE_COORDS_0 = TEXTURE_COORDS , TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1 , TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2 ,
TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3 , TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4 , TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5 , TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6 ,
TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7
}

typedef DrawableUpdateCallback | UpdateCallback
typedef DrawableEventCallback | EventCallback
typedef DrawableCullCallback | CullCallback
typedef unsigned int | AttributeType
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Drawable)
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual void | computeDataVariance ()
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setInitialBound (const osg::BoundingBox &bbox)
const BoundingBox & | getInitialBound () const
const BoundingSphere & | getBound () const
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
virtual BoundingBox | computeBoundingBox () const
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
virtual void | setShape (Shape *shape)
template<class T>
void | setShape (const ref_ptr< T > &shape)
Shape * | getShape ()
const Shape * | getShape () const
void | setSupportsDisplayList (bool flag)
bool | getSupportsDisplayList () const
void | setUseDisplayList (bool flag)
bool | getUseDisplayList () const
GLuint & | getDisplayList (unsigned int contextID) const
virtual void | setUseVertexBufferObjects (bool flag)
bool | getUseVertexBufferObjects () const
void | setUseVertexArrayObject (bool flag)
bool | getUseVertexArrayObject () const
virtual void | dirtyGLObjects ()
virtual unsigned int | getGLObjectSizeHint () const
void | draw (RenderInfo &renderInfo) const
void | drawInner (RenderInfo &renderInfo) const
virtual void | compileGLObjects (RenderInfo &renderInfo) const
void | setCreateVertexArrayStateCallback (CreateVertexArrayStateCallback *cb)
CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback ()
const CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback () const
VertexArrayState * | createVertexArrayState (RenderInfo &renderInfo) const
virtual VertexArrayState * | createVertexArrayStateImplementation (RenderInfo &renderInfo) const
void | setVertexArrayStateList (VertexArrayStateList &vasl)
VertexArrayStateList & | getVertexArrayStateList ()
const VertexArrayStateList & | getVertexArrayStateList () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
virtual void | setDrawCallback (DrawCallback *dc)
DrawCallback * | getDrawCallback ()
const DrawCallback * | getDrawCallback () const
virtual void | drawImplementation (RenderInfo &) const
virtual bool | supports (const AttributeFunctor &) const
virtual void | accept (AttributeFunctor &)
virtual bool | supports (const ConstAttributeFunctor &) const
virtual void | accept (ConstAttributeFunctor &) const
virtual bool | supports (const PrimitiveFunctor &) const
virtual void | accept (PrimitiveFunctor &) const
virtual bool | supports (const PrimitiveIndexFunctor &) const
virtual void | accept (PrimitiveIndexFunctor &) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
virtual void | traverse (NodeVisitor &)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
static void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
static void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
static unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef osg::buffered_value< GLuint > | GLObjectList

## Protected Member Functions

Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

BoundingBox | _initialBoundingBox
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundingBoxCallback
BoundingBox | _boundingBox
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
bool | _useVertexArrayObject
GLObjectList | _globjList
VertexArrayStateList | _vertexArrayStateList
ref_ptr< DrawCallback > | _drawCallback
ref_ptr< CreateVertexArrayStateCallback > | _createVertexArrayStateCallback
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Friends

class | Node
class | Geode
class | StateSet

## Detailed Description

Pure virtual base class for drawable geometry. In OSG, everything that can be rendered is implemented as a class derived from `Drawable`. The `Drawable` class contains no drawing primitives, since these are provided by subclasses such as `osg::Geometry`.

Notice that a `Drawable` is not a `Node`, and therefore it cannot be directly added to a scene graph. Instead, Drawables are attached to Geodes, which are scene graph nodes.

The OpenGL state that must be used when rendering a `Drawable` is represented by a `StateSet`. Since a `Drawable` has a reference (`osg::ref_ptr`) to a `StateSet`, StateSets can be shared between different Drawables. In fact, sharing StateSets is a good way to improve performance, since this allows OSG to reduce the number of expensive changes in the OpenGL state.

Finally, Drawables can also be shared between different Geodes, so that the same geometry (loaded to memory just once) can be used in different parts of the scene graph.

## Member Typedef Documentation

## AttributeType

typedef unsigned int osg::Drawable::AttributeType

## CullCallback

typedef DrawableCullCallback osg::Drawable::CullCallback

## EventCallback

typedef DrawableEventCallback osg::Drawable::EventCallback

## GLObjectList

typedef osg::buffered_value<GLuint> osg::Drawable::GLObjectList

protected

## UpdateCallback

typedef DrawableUpdateCallback osg::Drawable::UpdateCallback

## Member Enumeration Documentation

## AttributeTypes

enum osg::Drawable::AttributeTypes

Enumerator
VERTICES |
WEIGHTS |
NORMALS |
COLORS |
SECONDARY_COLORS |
FOG_COORDS |
ATTRIBUTE_6 |
ATTRIBUTE_7 |
TEXTURE_COORDS |
TEXTURE_COORDS_0 |
TEXTURE_COORDS_1 |
TEXTURE_COORDS_2 |
TEXTURE_COORDS_3 |
TEXTURE_COORDS_4 |
TEXTURE_COORDS_5 |
TEXTURE_COORDS_6 |
TEXTURE_COORDS_7 |

## Constructor & Destructor Documentation

## Drawable() [1/2]

osg::Drawable::Drawable | ( |  | ) |

Referenced by asDrawable(), asDrawable(), osg::DispatchCompute::DispatchCompute(), Drawable(), META_Node(), and operator=().

## Drawable() [2/2]

osg::Drawable::Drawable | ( | const Drawable & | drawable,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Drawable(), and osg::CopyOp::SHALLOW_COPY.

## ~Drawable()

virtual osg::Drawable::~Drawable | ( |  | ) |

protected virtual

## Member Function Documentation

## accept() [1/4]

virtual void osg::Drawable::accept | ( | AttributeFunctor & |  | ) |

inline virtual

accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls.

Reimplemented in osg::Geometry, osgTerrain::HeightFieldDrawable, and osgTerrain::SharedGeometry.

## accept() [2/4]

virtual void osg::Drawable::accept | ( | ConstAttributeFunctor & |  | ) | const

inline virtual

Accept an AttributeFunctor and call its methods to tell it about the internal attributes that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls.

Reimplemented in osg::Geometry, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, and osgText::Text.

## accept() [3/4]

virtual void osg::Drawable::accept | ( | PrimitiveFunctor & |  | ) | const

inline virtual

Accept a PrimitiveFunctor and call its methods to tell it about the internal primitives that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Note, PrimitiveFunctor only provides const access of the primitives, as primitives may be procedurally generated so one cannot modify it.

Reimplemented in osg::Geometry, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, and osgText::Text.

## accept() [4/4]

virtual void osg::Drawable::accept | ( | PrimitiveIndexFunctor & |  | ) | const

inline virtual

Accept a PrimitiveIndexFunctor and call its methods to tell it about the internal primitives that this Drawable has. return true if functor handled by drawable, return false on failure of drawable to generate functor calls. Note, PrimitiveIndexFunctor only provide const access of the primitives, as primitives may be procedurally generated so one cannot modify it.

Reimplemented in osg::Geometry, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, and osgTerrain::SharedGeometry.

## asDrawable() [1/2]

virtual Drawable * osg::Drawable::asDrawable | ( |  | ) |

inline virtual

Convert 'this' into a Drawable pointer if Object is a Drawable, otherwise return 0. Equivalent to dynamic_cast<Drawable*>(this).

Reimplemented from osg::Node.

References Drawable().

## asDrawable() [2/2]

virtual const Drawable * osg::Drawable::asDrawable | ( |  | ) | const

inline virtual

convert 'const this' into a const Drawable pointer if Object is a Drawable, otherwise return 0. Equivalent to dynamic_cast<const Drawable*>(this).

Reimplemented from osg::Node.

References Drawable().

## compileGLObjects()

virtual void osg::Drawable::compileGLObjects | ( | RenderInfo & | renderInfo | ) | const

virtual

Immediately compile this `Drawable` into an OpenGL Display List/VertexBufferObjects.

Note
  Operation is ignored if `_useDisplayList` is `false` or VertexBufferObjects are not used.

Reimplemented in osg::DispatchCompute, osg::Geometry, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, and osgText::TextBase.

## computeBound()

virtual BoundingSphere osg::Drawable::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Drawables's geometry.

Reimplemented from osg::Node.

## computeBoundingBox()

virtual BoundingBox osg::Drawable::computeBoundingBox | ( |  | ) | const

virtual

Compute the bounding box around Drawables's geometry.

Reimplemented in osg::DrawPixels, osgParticle::ParticleSystem, osgText::Text3D, and osgText::TextBase.

Referenced by getBoundingBox().

## computeDataVariance()

virtual void osg::Drawable::computeDataVariance | ( |  | ) |

virtual

Compute the DataVariance based on an assessment of callback etc.

Reimplemented from osg::Object.

## createVertexArrayState()

VertexArrayState * osg::Drawable::createVertexArrayState | ( | RenderInfo & | renderInfo | ) | const

inline

Create the VertexArrayState object used to track vertex array and vertex array object state. This method will be called automatically during rendering setup so users should not call this themselves.

References _createVertexArrayStateCallback, and createVertexArrayStateImplementation().

Referenced by draw().

## createVertexArrayStateImplementation()

virtual VertexArrayState * osg::Drawable::createVertexArrayStateImplementation | ( | RenderInfo & | renderInfo | ) | const

virtual

Implementation of Create the VertexArrayState object.

Reimplemented in osg::Geometry, osgParticle::ParticleSystem, osgTerrain::SharedGeometry, and osgText::TextBase.

Referenced by createVertexArrayState(), and osg::Drawable::CreateVertexArrayStateCallback::createVertexArrayStateImplementation().

## deleteDisplayList()

void osg::Drawable::deleteDisplayList | ( | unsigned int | contextID,
|  | GLuint | globj,
|  | unsigned int | sizeHint = 0 )

static

Use deleteDisplayList instead of glDeleteList to allow OpenGL display list to be cached until they can be deleted by the OpenGL context in which they were created, specified by contextID.

## dirtyGLObjects()

virtual void osg::Drawable::dirtyGLObjects | ( |  | ) |

virtual

Force a recompile on next draw() of any OpenGL objects associated with this geoset.

Reimplemented in osg::Geometry.

Referenced by setDrawCallback().

## draw()

void osg::Drawable::draw | ( | RenderInfo & | renderInfo | ) | const

inline

Draw OpenGL primitives. If the `Drawable` has `_useDisplayList` set to `true`, then use an OpenGL display list, automatically compiling one if required. Otherwise, call `drawImplementation()`.

Note
  This method should not be overridden in subclasses, as it manages the optional display list (notice this is not even `virtual`). Subclasses should override `drawImplementation()` instead.

References _globjList, _supportsVertexBufferObjects, _useDisplayList, _useVertexArrayObject, _useVertexBufferObjects, _vertexArrayStateList, osg::State::bindVertexArrayObject(), createVertexArrayState(), drawInner(), osg::Object::DYNAMIC, generateDisplayList(), osg::RenderInfo::getContextID(), osg::State::getCurrentVertexArrayState(), osg::Object::getDataVariance(), getGLObjectSizeHint(), osg::RenderInfo::getState(), osg::VertexArrayState::setRequiresSetArrays(), osg::State::useVertexArrayObject(), and osg::State::useVertexBufferObject().

## drawImplementation()

virtual void osg::Drawable::drawImplementation | ( | RenderInfo & |  | ) | const

inline virtual

drawImplementation(RenderInfo&) is a pure virtual method for the actual implementation of OpenGL drawing calls, such as vertex arrays and primitives, that must be implemented in concrete subclasses of the Drawable base class, examples include osg::Geometry and osg::ShapeDrawable. drawImplementation(RenderInfo&) is called from the draw(RenderInfo&) method, with the draw method handling management of OpenGL display lists, and drawImplementation(RenderInfo&) handling the actual drawing itself. renderInfo : The osg::RenderInfo object that encapsulates the current rendering information including the osg::State OpenGL state for the current graphics context.

Reimplemented in osg::DispatchCompute, osg::DrawPixels, osg::Geometry, osg::QueryGeometry, osgParticle::ConnectedParticleSystem, osgParticle::ParticleSystem, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::FadeText, osgText::Text3D, and osgText::Text.

Referenced by drawInner().

## drawInner()

void osg::Drawable::drawInner | ( | RenderInfo & | renderInfo | ) | const

inline

References _drawCallback, and drawImplementation().

Referenced by draw().

## generateDisplayList()

GLuint osg::Drawable::generateDisplayList | ( | unsigned int | contextID,
|  | unsigned int | sizeHint = 0 )

static

Return a OpenGL display list handle a newly generated or reused from display list cache.

Referenced by draw().

## getBound()

const BoundingSphere & osg::Drawable::getBound | ( |  | ) | const

inline

References osg::Node::_boundingSphere, osg::Node::_boundingSphereComputed, and getBoundingBox().

## getBoundingBox()

const BoundingBox & osg::Drawable::getBoundingBox | ( |  | ) | const

inline

Get BoundingBox of Drawable. If the BoundingBox is not up to date then its updated via an internal call to computeBond().

References _boundingBox, osg::Node::_boundingSphere, osg::Node::_boundingSphereComputed, _computeBoundingBoxCallback, _initialBoundingBox, and computeBoundingBox().

Referenced by getBound().

## getComputeBoundingBoxCallback() [1/2]

ComputeBoundingBoxCallback * osg::Drawable::getComputeBoundingBoxCallback | ( |  | ) |

inline

Get the compute bound callback.

References _computeBoundingBoxCallback.

## getComputeBoundingBoxCallback() [2/2]

const ComputeBoundingBoxCallback * osg::Drawable::getComputeBoundingBoxCallback | ( |  | ) | const

inline

Get the const compute bound callback.

References _computeBoundingBoxCallback.

## getCreateVertexArrayStateCallback() [1/2]

CreateVertexArrayStateCallback * osg::Drawable::getCreateVertexArrayStateCallback | ( |  | ) |

inline

Get the callback that overrides the default Drawable::createCreateVertexArrayStateImplementation().

References _createVertexArrayStateCallback.

## getCreateVertexArrayStateCallback() [2/2]

const CreateVertexArrayStateCallback * osg::Drawable::getCreateVertexArrayStateCallback | ( |  | ) | const

inline

Get the const callback that overrides the default Drawable::createCreateVertexArrayStateImplementation().

References _createVertexArrayStateCallback.

## getDisplayList()

GLuint & osg::Drawable::getDisplayList | ( | unsigned int | contextID | ) | const

inline

Return OpenGL display list for specified contextID.

References _globjList.

## getDrawCallback() [1/2]

DrawCallback * osg::Drawable::getDrawCallback | ( |  | ) |

inline

Get the non const DrawCallback.

References _drawCallback.

## getDrawCallback() [2/2]

const DrawCallback * osg::Drawable::getDrawCallback | ( |  | ) | const

inline

Get the const DrawCallback.

References _drawCallback.

## getGLObjectSizeHint()

virtual unsigned int osg::Drawable::getGLObjectSizeHint | ( |  | ) | const

inline virtual

Return the estimated size of GLObjects (display lists/vertex buffer objects) that are associated with this drawable. This size is used a hint for reuse of deleted display lists/vertex buffer objects.

Reimplemented in osg::Geometry.

Referenced by draw().

## getInitialBound()

const BoundingBox & osg::Drawable::getInitialBound | ( |  | ) | const

inline

Set the initial bounding volume to use when computing the overall bounding volume.

References _initialBoundingBox.

## getMinimumNumberOfDisplayListsToRetainInCache()

unsigned int osg::Drawable::getMinimumNumberOfDisplayListsToRetainInCache | ( |  | ) |

static

Get the minimum number of display lists to retain in the deleted display list cache.

## getShape() [1/2]

Shape * osg::Drawable::getShape | ( |  | ) |

inline

Get the Shape of the Drawable.

References _shape.

## getShape() [2/2]

const Shape * osg::Drawable::getShape | ( |  | ) | const

inline

Get the const Shape of the const Drawable.

References _shape.

## getSupportsDisplayList()

bool osg::Drawable::getSupportsDisplayList | ( |  | ) | const

inline

Get whether display lists are supported for this drawable instance.

References _supportsDisplayList.

## getUseDisplayList()

bool osg::Drawable::getUseDisplayList | ( |  | ) | const

inline

Return whether OpenGL display lists are being used for rendering.

References _useDisplayList.

## getUseVertexArrayObject()

bool osg::Drawable::getUseVertexArrayObject | ( |  | ) | const

inline

Return whether to use a local VertexArrayObject for this Drawable.

References _useVertexArrayObject.

## getUseVertexBufferObjects()

bool osg::Drawable::getUseVertexBufferObjects | ( |  | ) | const

inline

Return whether OpenGL vertex buffer objects should be used when supported by OpenGL driver.

References _useVertexBufferObjects.

## getVertexArrayStateList() [1/2]

VertexArrayStateList & osg::Drawable::getVertexArrayStateList | ( |  | ) |

inline

References _vertexArrayStateList.

## getVertexArrayStateList() [2/2]

const VertexArrayStateList & osg::Drawable::getVertexArrayStateList | ( |  | ) | const

inline

References _vertexArrayStateList.

## getWorldMatrices()

MatrixList osg::Drawable::getWorldMatrices | ( | const osg::Node * | haltTraversalAtNode = 0 | ) | const

Get the list of matrices that transform this node from local coordinates to world coordinates. The optional Node* haltTraversalAtNode allows the user to prevent traversal beyond a specified node.

## META_Node()

osg::Drawable::META_Node | ( | osg | ,
|  | Drawable | )

References Drawable().

## operator=()

Drawable & osg::Drawable::operator= | ( | const Drawable & |  | ) |

inline protected

References Drawable().

## releaseGLObjects()

virtual void osg::Drawable::releaseGLObjects | ( | State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Node.

Reimplemented in osg::Geometry, osg::QueryGeometry, osgParticle::ParticleSystem, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, osgText::Text, and osgText::TextBase.

## resizeGLObjectBuffers()

virtual void osg::Drawable::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Node.

Reimplemented in osg::Geometry, osgParticle::ParticleSystem, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, osgText::Text, and osgText::TextBase.

## setBound()

void osg::Drawable::setBound | ( | const BoundingBox & | bb | ) | const

protected

set the bounding box .

## setComputeBoundingBoxCallback()

void osg::Drawable::setComputeBoundingBoxCallback | ( | ComputeBoundingBoxCallback * | callback | ) |

inline

Set the compute bound callback to override the default computeBound.

References _computeBoundingBoxCallback.

## setCreateVertexArrayStateCallback()

void osg::Drawable::setCreateVertexArrayStateCallback | ( | CreateVertexArrayStateCallback * | cb | ) |

inline

Set the callback to override the default Drawable::createCreateVertexArrayStateImplementation().

References _createVertexArrayStateCallback.

## setDrawCallback()

virtual void osg::Drawable::setDrawCallback | ( | DrawCallback * | dc | ) |

inline virtual

Set the DrawCallback which allows users to attach customize the drawing of existing Drawable object.

References _drawCallback, and dirtyGLObjects().

## setInitialBound()

void osg::Drawable::setInitialBound | ( | const osg::BoundingBox & | bbox | ) |

inline

Set the initial bounding volume to use when computing the overall bounding volume.

References _initialBoundingBox, and osg::Node::dirtyBound().

## setMinimumNumberOfDisplayListsToRetainInCache()

void osg::Drawable::setMinimumNumberOfDisplayListsToRetainInCache | ( | unsigned int | minimum | ) |

static

Set the minimum number of display lists to retain in the deleted display list cache.

References osg::minimum().

## setShape() [1/2]

template<class T>

void osg::Drawable::setShape | ( | const ref_ptr< T > & | shape | ) |

inline

References osg::ref_ptr< T >::get(), and setShape().

Referenced by setShape().

## setShape() [2/2]

virtual void osg::Drawable::setShape | ( | Shape * | shape | ) |

inline virtual

Set the Shape of the `Drawable`. The shape can be used to speed up collision detection or as a guide for procedural geometry generation.

See also
  osg::Shape.

Reimplemented in osg::ShapeDrawable.

References _shape.

## setSupportsDisplayList()

void osg::Drawable::setSupportsDisplayList | ( | bool | flag | ) |

Set the drawable so that it can or cannot be used in conjunction with OpenGL display lists. When set to true, calls to Drawable::setUseDisplayList, whereas when set to false, no display lists can be created and calls to setUseDisplayList are ignored, and a warning is produced. The latter is typically used to guard against the switching on of display lists on objects with dynamic internal data such as continuous Level of Detail algorithms.

## setThreadSafeRefUnref()

virtual void osg::Drawable::setThreadSafeRefUnref | ( | bool | threadSafe | ) |

virtual

Set whether to use a mutex to ensure ref() and unref() are thread safe.

Reimplemented from osg::Node.

## setUseDisplayList()

void osg::Drawable::setUseDisplayList | ( | bool | flag | ) |

When set to true, force the draw method to use OpenGL Display List for rendering. If false, rendering directly. If the display list has not been compiled already, the next call to draw will automatically create the display list.

## setUseVertexArrayObject()

void osg::Drawable::setUseVertexArrayObject | ( | bool | flag | ) |

Set whether to use a local VertexArrayObject for this Drawable.

## setUseVertexBufferObjects()

virtual void osg::Drawable::setUseVertexBufferObjects | ( | bool | flag | ) |

virtual

When set to true, ignore the setUseDisplayList() settings, and hints to the drawImplementation method to use OpenGL vertex buffer objects for rendering.

Reimplemented in osg::Geometry.

## setVertexArrayStateList()

void osg::Drawable::setVertexArrayStateList | ( | VertexArrayStateList & | vasl | ) |

inline

References _vertexArrayStateList.

## supports() [1/4]

virtual bool osg::Drawable::supports | ( | const AttributeFunctor & |  | ) | const

inline virtual

Return true if the Drawable subclass supports accept(AttributeFunctor&).

Reimplemented in osg::Geometry, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, and osgText::Text.

## supports() [2/4]

virtual bool osg::Drawable::supports | ( | const ConstAttributeFunctor & |  | ) | const

inline virtual

Return true if the Drawable subclass supports accept(ConstAttributeFunctor&).

Reimplemented in osg::Geometry, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, and osgText::Text.

## supports() [3/4]

virtual bool osg::Drawable::supports | ( | const PrimitiveFunctor & |  | ) | const

inline virtual

Return true if the Drawable subclass supports accept(PrimitiveFunctor&).

Reimplemented in osg::Geometry, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, osgTerrain::SharedGeometry, osgText::Text3D, and osgText::Text.

## supports() [4/4]

virtual bool osg::Drawable::supports | ( | const PrimitiveIndexFunctor & |  | ) | const

inline virtual

Return true if the Drawable subclass supports accept(PrimitiveIndexFunctor&).

Reimplemented in osg::Geometry, osgParticle::PrecipitationEffect::PrecipitationDrawable, osgTerrain::HeightFieldDrawable, and osgTerrain::SharedGeometry.

## Friends And Related Symbol Documentation

## Geode

friend class Geode

friend

References Geode.

Referenced by Geode.

## Node

friend class Node

friend

References Node.

Referenced by Node.

## StateSet

friend class StateSet

friend

References StateSet.

Referenced by StateSet.

## Member Data Documentation

## _boundingBox

BoundingBox osg::Drawable::_boundingBox

mutable protected

Referenced by getBoundingBox().

## _computeBoundingBoxCallback

ref_ptr<ComputeBoundingBoxCallback> osg::Drawable::_computeBoundingBoxCallback

protected

Referenced by getBoundingBox(), getComputeBoundingBoxCallback(), getComputeBoundingBoxCallback(), and setComputeBoundingBoxCallback().

## _createVertexArrayStateCallback

ref_ptr<CreateVertexArrayStateCallback> osg::Drawable::_createVertexArrayStateCallback

protected

Referenced by createVertexArrayState(), getCreateVertexArrayStateCallback(), getCreateVertexArrayStateCallback(), and setCreateVertexArrayStateCallback().

## _drawCallback

ref_ptr<DrawCallback> osg::Drawable::_drawCallback

protected

Referenced by drawInner(), getDrawCallback(), getDrawCallback(), and setDrawCallback().

## _globjList

GLObjectList osg::Drawable::_globjList

mutable protected

Referenced by draw(), and getDisplayList().

## _initialBoundingBox

BoundingBox osg::Drawable::_initialBoundingBox

protected

Referenced by getBoundingBox(), getInitialBound(), and setInitialBound().

## _shape

ref_ptr<Shape> osg::Drawable::_shape

protected

Referenced by getShape(), getShape(), and setShape().

## _supportsDisplayList

bool osg::Drawable::_supportsDisplayList

protected

Referenced by getSupportsDisplayList().

## _supportsVertexBufferObjects

bool osg::Drawable::_supportsVertexBufferObjects

protected

Referenced by draw().

## _useDisplayList

bool osg::Drawable::_useDisplayList

protected

Referenced by draw(), and getUseDisplayList().

## _useVertexArrayObject

bool osg::Drawable::_useVertexArrayObject

protected

Referenced by draw(), and getUseVertexArrayObject().

## _useVertexBufferObjects

bool osg::Drawable::_useVertexBufferObjects

protected

Referenced by draw(), and getUseVertexBufferObjects().

## _vertexArrayStateList

VertexArrayStateList osg::Drawable::_vertexArrayStateList

mutable protected

Referenced by draw(), getVertexArrayStateList(), getVertexArrayStateList(), and setVertexArrayStateList().

The documentation for this class was generated from the following file:

- Drawable